searchNodes=[{"doc":"A collection of utility functions to use this library.","ref":"LcdDisplay.html","title":"LcdDisplay","type":"module"},{"doc":"Executes a supported command that is specified.","ref":"LcdDisplay.html#execute/2","title":"LcdDisplay.execute/2","type":"function"},{"doc":"Starts a supervised display controller process.","ref":"LcdDisplay.html#start_display/2","title":"LcdDisplay.start_display/2","type":"function"},{"doc":"Wraps a given display driver and controls the display using that driver.","ref":"LcdDisplay.DisplayController.html","title":"LcdDisplay.DisplayController","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplayController.html#child_spec/1","title":"LcdDisplay.DisplayController.child_spec/1","type":"function"},{"doc":"Delegates the specified operation to the display driver, and updates the state as needed.ExamplesDisplayController.execute(pid, {:print, &quot;Hello&quot;})","ref":"LcdDisplay.DisplayController.html#execute/2","title":"LcdDisplay.DisplayController.execute/2","type":"function"},{"doc":"Starts a display driver process and registers the process with a composite key of driver module and display name.","ref":"LcdDisplay.DisplayController.html#start_link/1","title":"LcdDisplay.DisplayController.start_link/1","type":"function"},{"doc":"Discovers a process by the composite key of driver module atom and display name.","ref":"LcdDisplay.DisplayController.html#whereis/1","title":"LcdDisplay.DisplayController.whereis/1","type":"function"},{"doc":"Supervises display controller processes.","ref":"LcdDisplay.DisplaySupervisor.html","title":"LcdDisplay.DisplaySupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplaySupervisor.html#child_spec/1","title":"LcdDisplay.DisplaySupervisor.child_spec/1","type":"function"},{"doc":"Creates a LcdDisplay.DisplayController process.Examplespid = DisplaySupervisor.display_controller( LcdDisplay.HD44780.PCF8575, %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } )","ref":"LcdDisplay.DisplaySupervisor.html#display_controller/2","title":"LcdDisplay.DisplaySupervisor.display_controller/2","type":"function"},{"doc":"","ref":"LcdDisplay.DisplaySupervisor.html#start_link/1","title":"LcdDisplay.DisplaySupervisor.start_link/1","type":"function"},{"doc":"Defines a behaviour required for an LCD driver.","ref":"LcdDisplay.Driver.html","title":"LcdDisplay.Driver","type":"behaviour"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.Driver.html#c:execute/2","title":"LcdDisplay.Driver.execute/2","type":"callback"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.Driver.html#c:start/1","title":"LcdDisplay.Driver.start/1","type":"callback"},{"doc":"Type that represents a supported display command.Supported CommandDescription:clearClear the display.:homeMove the cursor home.:printPrint a text at the current cursor.:set_cursorSet the cursor position (row and column).:cursorSwitch on/off the underline cursor.:displaySwitch on/off the display without losing what is on it.:blinkSwitch on/off the block cursor.:autoscrollMake existing text shift when new text is printed.:backlightSwitch on/off the backlight.:text_directionMake text flow left/right from the cursor.:scrollScroll text left and right.:leftMove the cursor left.:rightMove the cursor right.:charProgram custom character to CGRAM.","ref":"LcdDisplay.Driver.html#t:command/0","title":"LcdDisplay.Driver.command/0","type":"type"},{"doc":"","ref":"LcdDisplay.Driver.html#t:config/0","title":"LcdDisplay.Driver.config/0","type":"type"},{"doc":"Type that represents an available display feature.","ref":"LcdDisplay.Driver.html#t:feature/0","title":"LcdDisplay.Driver.feature/0","type":"type"},{"doc":"","ref":"LcdDisplay.Driver.html#t:num_cols/0","title":"LcdDisplay.Driver.num_cols/0","type":"type"},{"doc":"","ref":"LcdDisplay.Driver.html#t:num_rows/0","title":"LcdDisplay.Driver.num_rows/0","type":"type"},{"doc":"Type that represents the display state.","ref":"LcdDisplay.Driver.html#t:t/0","title":"LcdDisplay.Driver.t/0","type":"type"},{"doc":"A collection of utility functions that are used for display drivers.","ref":"LcdDisplay.DriverUtil.html","title":"LcdDisplay.DriverUtil","type":"module"},{"doc":"Determine a list of row offsets based on how many columns the display has.0x00: | ROW 0 | ROW 2 | 0x40: | ROW 1 | ROW 3 |For more info, please refer to Hitachi HD44780 datasheet page 10.Examplesiex&gt; LcdDisplay.DriverUtil.ddram_row_offsets(8) {0, 64, 8, 72} iex&gt; LcdDisplay.DriverUtil.ddram_row_offsets(16) {0, 64, 16, 80} iex&gt; LcdDisplay.DriverUtil.ddram_row_offsets(20) {0, 64, 20, 84}","ref":"LcdDisplay.DriverUtil.html#ddram_row_offsets/1","title":"LcdDisplay.DriverUtil.ddram_row_offsets/1","type":"function"},{"doc":"Determines a Display Data RAM (DDRAM) address based on the display configuration (rows and columns) and the zero-indexed cursor position (row and column).Examplesiex&gt; LcdDisplay.DriverUtil.determine_ddram_address({0,0}, %{rows: 2, cols: 16}) 0 iex&gt; LcdDisplay.DriverUtil.determine_ddram_address({0,15}, %{rows: 2, cols: 16}) 15 iex&gt; LcdDisplay.DriverUtil.determine_ddram_address({1,0}, %{rows: 2, cols: 16}) 64 iex&gt; LcdDisplay.DriverUtil.determine_ddram_address({1,15}, %{rows: 2, cols: 16}) 79","ref":"LcdDisplay.DriverUtil.html#determine_ddram_address/2","title":"LcdDisplay.DriverUtil.determine_ddram_address/2","type":"function"},{"doc":"Typically 2x16 or 4x20.","ref":"LcdDisplay.DriverUtil.html#t:display_config/0","title":"LcdDisplay.DriverUtil.display_config/0","type":"type"},{"doc":"","ref":"LcdDisplay.DriverUtil.html#t:row_col_pos/0","title":"LcdDisplay.DriverUtil.row_col_pos/0","type":"type"},{"doc":"Lets you control GPIOs. A thin wrapper of elixir-circuits/circuits_gpio.","ref":"LcdDisplay.GPIO.html","title":"LcdDisplay.GPIO","type":"module"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.open/2.","ref":"LcdDisplay.GPIO.html#open/2","title":"LcdDisplay.GPIO.open/2","type":"function"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.write/2.","ref":"LcdDisplay.GPIO.html#write/2","title":"LcdDisplay.GPIO.write/2","type":"function"},{"doc":"Defines a behaviour required for GPIO abstraction.","ref":"LcdDisplay.GPIO.Behaviour.html","title":"LcdDisplay.GPIO.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:open/2","title":"LcdDisplay.GPIO.Behaviour.open/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:write/2","title":"LcdDisplay.GPIO.Behaviour.write/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#t:gpio_pin/0","title":"LcdDisplay.GPIO.Behaviour.gpio_pin/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display via GPIO pins. Supports the 4-bit mode only. You can turn on/off one backlight LED.Examplesalias LcdDisplay.HD44780 config = %{ display_name: &quot;display 1&quot;, pin_rs: 2, pin_rw: 3, pin_en: 4, pin_d4: 23, pin_d5: 24, pin_d6: 25, pin_d7: 26, pin_led: 12, } # Start the LCD driver and get the initial display state. {:ok, display} = HD44780.GPIO.start(config) # Run a command and the display state will be updated. {:ok, display} = HD44780.GPIO.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.GPIO.html","title":"LcdDisplay.HD44780.GPIO","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.GPIO.html#execute/2","title":"LcdDisplay.HD44780.GPIO.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.GPIO.html#start/1","title":"LcdDisplay.HD44780.GPIO.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.GPIO.html#t:config/0","title":"LcdDisplay.HD44780.GPIO.config/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 8-Bit I/O Expander with Serial Interface MCP23008. You can turn on/off one backlight LED.Usageiex(2)&gt; Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 32 (0x20) 1 devices detected on 1 I2C busesconfig = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x20, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.MCP23008.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.MCP23008.execute(display, {:print, &quot;Hello world&quot;})MCP23008pin assignmentThis module assumes the following pin assignment:MCP23008HD44780GP0-GP1RS (Register Select)GP2E (Enable)GP3DB4 (Data Bus 4)GP4DB5 (Data Bus 5)GP5DB6 (Data Bus 6)GP6DB7 (Data Bus 7)GP7LEDData byte76543210LEDDB7DB6DB5DB4ERS-","ref":"LcdDisplay.HD44780.MCP23008.html","title":"LcdDisplay.HD44780.MCP23008","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.MCP23008.html#execute/2","title":"LcdDisplay.HD44780.MCP23008.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.MCP23008.html#start/1","title":"LcdDisplay.HD44780.MCP23008.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.MCP23008.html#t:config/0","title":"LcdDisplay.HD44780.MCP23008.config/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 16-bit I/O expander PCF8575. You can turn on/off one backlight LED.Usageiex(2)&gt; Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 39 (0x27) 1 devices detected on 1 I2C busesconfig = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.PCF8575.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.PCF8575.execute(display, {:print, &quot;Hello world&quot;})PCF8575pin assignmentThis module assumes the following pin assignment:PCF8575HD44780P0RS (Register Select)P1-P2E (Enable)P3LEDP4DB4 (Data Bus 4)P5DB5 (Data Bus 5)P6DB6 (Data Bus 6)P7DB7 (Data Bus 7)Data byte76543210DB7DB6DB5DB4LEDE-RS","ref":"LcdDisplay.HD44780.PCF8575.html","title":"LcdDisplay.HD44780.PCF8575","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.PCF8575.html#execute/2","title":"LcdDisplay.HD44780.PCF8575.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.PCF8575.html#start/1","title":"LcdDisplay.HD44780.PCF8575.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.PCF8575.html#t:config/0","title":"LcdDisplay.HD44780.PCF8575.config/0","type":"type"},{"doc":"Lets you communicate with hardware devices using the I2C protocol. A thin wrapper of elixir-circuits/circuits_i2c.","ref":"LcdDisplay.I2C.html","title":"LcdDisplay.I2C","type":"module"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.open/1.","ref":"LcdDisplay.I2C.html#open/1","title":"LcdDisplay.I2C.open/1","type":"function"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.write/3.","ref":"LcdDisplay.I2C.html#write/3","title":"LcdDisplay.I2C.write/3","type":"function"},{"doc":"Defines a behaviour required for I2C abstraction.","ref":"LcdDisplay.I2C.Behaviour.html","title":"LcdDisplay.I2C.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:open/1","title":"LcdDisplay.I2C.Behaviour.open/1","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:write/3","title":"LcdDisplay.I2C.Behaviour.write/3","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:data/0","title":"LcdDisplay.I2C.Behaviour.data/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_address/0","title":"LcdDisplay.I2C.Behaviour.i2c_address/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_bus/0","title":"LcdDisplay.I2C.Behaviour.i2c_bus/0","type":"type"},{"doc":"Manages processes.","ref":"LcdDisplay.ProcessRegistry.html","title":"LcdDisplay.ProcessRegistry","type":"module"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#child_spec/1","title":"LcdDisplay.ProcessRegistry.child_spec/1","type":"function"},{"doc":"Starts a unique registry.","ref":"LcdDisplay.ProcessRegistry.html#start_link/0","title":"LcdDisplay.ProcessRegistry.start_link/0","type":"function"},{"doc":"Returns a standardized via-tuple for this registry.Examplesiex&gt; ProcessRegistry.via_tuple(SomeKey) {:via, Registry, {ProcessRegistry, SomeKey}}","ref":"LcdDisplay.ProcessRegistry.html#via_tuple/1","title":"LcdDisplay.ProcessRegistry.via_tuple/1","type":"function"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#whereis_name/1","title":"LcdDisplay.ProcessRegistry.whereis_name/1","type":"function"},{"doc":"LcdDisplay LcdDisplay allows you to control a Liquid-crystal display (LCD) like Hitachi HD44780 from Elixir.Here is the documentation and example apps for this library.For more info on the display, please refer to Hitachi HD44780 data sheet.","ref":"readme.html","title":"LcdDisplay","type":"extras"},{"doc":"You can install LcdDisplay by adding lcd_display to your list of dependencies in mix.exs:def deps do [ {:lcd_display, &quot;0.0.17&quot;} ] end","ref":"readme.html#installation","title":"LcdDisplay - Installation","type":"extras"},{"doc":"As an example, if you want to control a Hitachi HD44780 type display through the 16-bit I/O expander PCF8575, you can use LcdDisplay.HD44780.PCF8575 module as a display driver.Start an LCD driver and get a PIDdriver_module = LcdDisplay.HD44780.PCF8575 driver_config = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } pid = LcdDisplay.start_display(driver_module, driver_config)Run commandsPlease refer to the LcdDisplay.Driver documentation for supported display commands.LcdDisplay.execute(pid, {:print, &quot;Hello world&quot;}) LcdDisplay.execute(pid, :clear)","ref":"readme.html#usage","title":"LcdDisplay - Usage","type":"extras"},{"doc":"ExLCD for inspiration","ref":"readme.html#thanks","title":"LcdDisplay - Thanks","type":"extras"},{"doc":"Hitachi HD44780 data sheetPCF8575 data sheetMCP23008 data sheet","ref":"readme.html#links","title":"LcdDisplay - Links","type":"extras"}]